#include <stdio.h>
#include <string.h>

char lab[1002][1002];
int best;
int k,nd,nx,ny;
int i;

#define down 1
#define up 2
#define left 3
#define right 4


int getpathnotindir(int x,int y,int d) {
  int m1,m2,m3,len;
  if (lab[x][y]=='#') return 0;
  len=1;
  do {
    k=0;
    nx=x; ny=y;
    if (d!=left && lab[x-1][y]=='.') { nd=right; nx=x-1; k++; }
    if (d!=right && lab[x+1][y]=='.') { nd=left; nx=x+1; k++; }
    if (d!=down && lab[x][y+1]=='.') { nd=up; ny=y+1; k++; }
    if (d!=up && lab[x][y-1]=='.') { nd=down; ny=y-1; k++; }
    if (k==1) {
      len++;
      x=nx; y=ny; d=nd;
    }
  } while(k==1); 
  //  printf("k = %d,len = %d\n",k,len);
  if (lab[x][y]=='#' || k == 0)
    return len;

  switch(d) {
  case left:
    m1=getpathnotindir(x+1,y,left);
    m2=getpathnotindir(x,y-1,down);
    m3=getpathnotindir(x,y+1,up);
    break;
  case right:
    m1=getpathnotindir(x-1,y,right);
    m2=getpathnotindir(x,y-1,down);
    m3=getpathnotindir(x,y+1,up);
    break;
  case up:
    m1=getpathnotindir(x+1,y,left);
    m2=getpathnotindir(x-1,y,right);
    m3=getpathnotindir(x,y+1,up);
    break;
  case down:
    m1=getpathnotindir(x+1,y,left);
    m2=getpathnotindir(x,y-1,down);
    m3=getpathnotindir(x-1,y,right);
    break;
  }  
  {
    int s1,s2,s3,max;

    if (m2>m1)
      max = m2;
    else
      max = m1;
    if (m3>max)
      max = m3;
    
    s1=m1+m2;
    s2=m1+m3;
    s3=m2+m3;
    if (s1>best) best=s1;
    if (s2>best) best=s2;
    if (s3>best) best=s3;
    return max+len;
  }
};

int main() {
  int t,c,r;
  int m1,m2;

  scanf("%d", &t);
  while (t--) {
    int x,y;

    best = 0;

    scanf("%d", &c);
    scanf("%d", &r);
    for (i = 0; i < r; i++)
      scanf("%s",lab[i]);

    for (x=1;x<r-1;x++)
      for (y=1;y<c-1;y++)
	if (lab[x][y] == '.')
	  goto daley;

    printf("Maximum rope length is 0.\n");
    continue;

  daley:
    m1=getpathnotindir(x+1,y,left);
    m2=getpathnotindir(x,y+1,up);
    //    printf("%d,%d\n",m1,m2);    
    if (m1 + m2 > best) best=m1+m2;
    printf("Maximum rope length is %d.\n",best);
  }

  return 0;
}
